/*******************************************************************************
 *	@file			DLSound.h
 *	@brief			DirectX Library
 *
 *	@date			20-Jun-2010(Sun)
 ******************************************************************************/

#ifndef	__DLSOUND_INCLUDE__
#define	__DLSOUND_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"
#include <vector>

using namespace std;

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@enum		enumPlay		DLSound.h		"DLSound.h"
 *	@brief		Đ
 ******************************************************************************/
enum enumPlay
{
	enumPlay_Null			= 0,												//!< Ȃ
	enumPlay_Wait,																//!< ҋ@
	enumPlay_Play,																//!< Đ
	enumPlay_Loop,																//!< [vĐ
	enumPlay_Stop,																//!< ~
	enumPlay_Max,
};

// \̒`-------------------------------------------------------------------
/*******************************************************************************
 *	@struct		DSDEVICE		DLSound.h		"DLSound.h"
 *	@brief		foCX\
 ******************************************************************************/
struct DSDEVICE
{
	DSDEVICE( const LPGUID& lpGuid = NULL,
			  const LPCSTR& lpDesc = NULL,
			  const LPCSTR& lpModule = NULL )
		: m_lpGuid( lpGuid )
		, m_lpDesc( lpDesc )
		, m_lpModule( lpModule )
	{
	}

	//
	LPGUID					m_lpGuid;											//!< GUID
	LPCSTR					m_lpDesc;											//!< foCX
	LPCSTR					m_lpModule;											//!< W[
};

/*******************************************************************************
 *	@struct		DSBUFFER		DLSound.h		"DLSound.h"
 *	@brief		obt@\
 ******************************************************************************/
struct DSBUFFER
{
	DSBUFFER()
		: m_lpBuffer( NULL )
		, m_DSDesc()

		, m_szName()
	{
	}

	// f[^
	LPDIRECTSOUNDBUFFER8	m_lpBuffer;											//!< ZJ_Eobt@
	DSBUFFERDESC			m_DSDesc;											//!< obt@

	LPCSTR					m_szName;											//!< O
};

/*******************************************************************************
 *	@struct		DSOBJECT		DLSound.h		"DLSound.h"
 *	@brief		IuWFNg\
 ******************************************************************************/
struct DSOBJECT
{
	DSOBJECT()
		: m_bUsed( FALSE )
		, m_eObj( enumObject_Null )
		, m_nPrio( -1 )
		, m_nMatNum( -1 )
		, m_ePlay( enumPlay_Wait )
	{
	}

	// {
	BOOL					m_bUsed;											//!< gptO
	enumObject				m_eObj;												//!< IuWFNg
	int						m_nPrio;											//!< `vCIeB
	// f
	int						m_nMatNum;											//!< fޔԍ
	// 
	enumPlay				m_ePlay;											//!< Đ
};

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CDLSound		DLSound.h			"DLSound.h"
 *	@brief		CDLSoundNX
 ******************************************************************************/
class CDLSound
{
// 萔`---------------------------------------------------------------------
private:
	static const int BUFFER_MAX		= 32;										//!< obt@
	static const int OBJECT_MAX		= 64;										//!< IuWFNg

protected:
public:

// o֐-------------------------------------------------------------------
private:
	static int ( CDLSound::*StepDel[ enumObject_SoundEnd - enumObject_SoundStart ] )( const int& nNum );
	static int ( CDLSound::*StepPlay[ enumPlay_Max ] )( const int& nNum );

	static BOOL CALLBACK DSEnumCallback( LPGUID lpGuid,
										 LPCSTR lpcstrDescription,
										 LPCSTR lpcstrModule,
										 LPVOID lpContext );					//!< foCX̗

	int CheckWave( const BYTE* byData );										//!< Wave

	// IuWFNg폜
	int DelBGM( const int& nNum );												//!< BGM폜
	int DelSE( const int& nNum );												//!< SE폜

	// IuWFNgs
	int ExecPlay( const int& nNum );												//!< Đ
	int ExecLoop( const int& nNum );												//!< 
	int ExecStop( const int& nNum );												//!< 

protected:
public:
	CDLSound( void );
	~CDLSound( void );

	int Init( const HWND& hWnd );												//!< 
	int End( void );															//!< I

	// ڊ
	DSBUFFER* GetBuffer( const int& nNum );										//!< obt@擾
	DSOBJECT* GetObject( const int& nNum );										//!< IuWFNg擾

	// fޓǂݍ
	int LoadWav( const int& nNum,
				 const LPCSTR& szName );										//!< Waveǂݍ

	// fމ
	int RemoveWav( const int& nNum );											//!< Wave
	int RemoveALL( void );														//!< fޑS

	// IuWFNgǉ
	int AddBGM( const int& nNum,
				const int& nPrio,
				const int& nMatNum,
				const enumPlay& ePlay );										//!< BGMǉ
	int AddSE( const int& nNum,
			   const int& nPrio,
			   const int& nMatNum,
			   const enumPlay& ePlay );											//!< SEǉ

	// IuWFNg폜
	int Del( const int& nNum );													//!< IuWFNg폜
	int DelALL( void );															//!< IuWFNgS폜

	// IuWFNgs
	int Play( const int& nNum );												//!< IuWFNgs

// oϐ-------------------------------------------------------------------
private:
	LPDIRECTSOUND8			m_lpSound;											//!< DirectSound IuWFNg
	DSBUFFERDESC			m_DSDesc;											//!< obt@
	LPDIRECTSOUNDBUFFER		m_lpPrimary;										//!< vC}Eobt@

	HWND					m_hWnd;												//!< EChEnh
	vector< DSDEVICE >		m_vDevice;											//!< foCX
	DSCAPS					m_DSCaps;											//!< foCX̔\
	DWORD					m_dwSpeaker;										//!< Xs[J[\

	// IuWFNg
	DSBUFFER				m_DSBuf[ BUFFER_MAX ];								//!< obt@\
	DSOBJECT				m_DSObj[ OBJECT_MAX ];								//!< IuWFNg\

protected:
public:

};

// OO[oϐ---------------------------------------------------------

// O֐vg^Cv錾---------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLSOUND_INCLUDE__
